/*
** Q[OtBbNX_p⏕vO
**

Copyright (c) 2011, 2012 Kohe Tokoi. All Rights Reserved.

Permission is hereby granted, free of charge,  to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction,  including without limitation the rights 
to use, copy,  modify, merge,  publish, distribute,  sublicense,  and/or sell 
copies or substantial portions of the Software.

The above  copyright notice  and this permission notice  shall be included in 
all copies or substantial portions of the Software.

THE SOFTWARE  IS PROVIDED "AS IS",  WITHOUT WARRANTY OF ANY KIND,  EXPRESS OR 
IMPLIED,  INCLUDING  BUT  NOT LIMITED  TO THE WARRANTIES  OF MERCHANTABILITY, 
FITNESS  FOR  A PARTICULAR PURPOSE  AND NONINFRINGEMENT.  IN  NO EVENT  SHALL 
KOHE TOKOI  BE LIABLE FOR ANY CLAIM,  DAMAGES OR OTHER LIABILITY,  WHETHER IN 
AN ACTION  OF CONTRACT,  TORT  OR  OTHERWISE,  ARISING  FROM,  OUT OF  OR  IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

**
*/

#ifndef __GG_H__
#define __GG_H__

#include <cstring>

#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  pragma warning(disable:4996)
#  pragma comment(lib, "glew32.lib")
#  include "glew.h"
#  include "wglew.h"
#  include "glut.h"
#elif defined(__APPLE__)
#  define GL_DO_NOT_WARN_IF_MULTI_GL_VERSION_HEADERS_INCLUDED
#  include <OpenGL/OpenGL.h>
#  include <OpenGL/gl3.h>
#  include <GLUT/glut.h>
#elif defined(X11)
#  define GL_GLEXT_PROTOTYPES
#  define GLX_GLXEXT_PROTOTYPES
#  include <GL/glut.h>
#  include <GL/glx.h>
#else
#  error "This platform is not supported."
#endif

namespace gg
{
  /*
  ** Q[OtBbNX_̓sɂƂÂ
  **
  **     OpenGL ̃_OReLXg쐬Ɏs
  */
  extern void ggInit(void);

  /*
  ** OpenGL ̃G[`FbN
  **
  **     OpenGL  API ĂяoɎs΃G[̂ƂɃbZ[W\
  */
  extern void ggError(
    const char *msg = 0                 // o͂郁bZ[W̐擪ɒǉ镶
    );

  /*
  ** FBO ̃G[`FbN
  **
  **     FBO  API ĂяoɎs΃G[̂ƂɃbZ[W\
  */
  extern void ggFBOError(
    const char *msg = 0                 // o͂郁bZ[W̐擪ɒǉ镶
    );

  /*
  ** VF[_[\[Xt@C̓ǂݍ
  */
  extern GLuint ggLoadShader(           // VF[_vÕvO
    const char *vert,                   // o[ebNXVF[_̃\[Xt@C
    const char *frag = 0,               // tOgVF[_̃\[Xt@Ci0 Ȃsgpj
    const char *geom = 0,               // WIgVF[_̃\[Xt@Ci0 Ȃsgpj
    GLenum input = GL_TRIANGLES,        // WIgVF[_̓̓v~eBu
    GLenum output = GL_TRIANGLE_STRIP,  // WIgVF[_̏o̓v~eBu
    int vertices = 0,                   // WIgVF[_̏o͒_
    int nvarying = 0,                   // tB[hobN varying ϐ̐i0 Ȃsgpj
    const char **varyings = 0           // tB[hobN varying ϐ̃Xg
    );

  /*
  ** J[obt@̓e TGA t@Cɕۑ
  */
  extern bool ggSaveColor(              // ǂݍ݂ł true
    const char *name                    // ۑt@C
    );

  /*
  ** fvXobt@̓e TGA t@Cɕۑ
  */
  extern bool ggSaveDepth(              // ۑł true
    const char *name                    // ۑt@C
    );

  /*
  ** TGA t@C (8/16/24/32bit) ̓ǂݍ
  */
  extern GLubyte *ggLoadTga(            // ǂݍ񂾉摜f[^̃|C^Ԃ (gp delete )
    const char *name,                   // ǂݍރt@C
    GLsizei &width,                     // ǂݍ TGA t@C̕
    GLsizei &height,                    // ǂݍ TGA t@C̍
    GLenum &format                      // ǂݍ TGA t@C̏ (GL_R, GL_RG, GL_BGR, GL_BGRA)
    );

  /*
  ** eNX`̊m
  */
  extern void ggLoadTexture(
    GLsizei width,                      // mۂeNX`̕
    GLsizei height,                     // mۂeNX`̍
    GLenum internal,                    // mۂeNX`̓
    GLenum format = GL_RGBA,            // image ̏
    const GLvoid *image = 0
    );

  /*
  ** TGA t@CeNX`ɓǂݍ
  */
  extern bool ggLoadImage(              // ǂݍ݂ł true
    const char *name,                   // ǂݍރt@C
    GLenum internal                     // eNX`̓tH[}bg
    );

  /*
  ** TGA 摜t@C̍}bvǂݍŃeNX`ɖ@}bv쐬
  */
  extern bool ggLoadHeight(             // ǂݍ݂ł true
    const char *name,                   // ǂݍރt@C
    float nz                            // @ z ̒
    );

  /*
  ** Op`ꂽ OBJ t@Cǂݍ (Elements `)
  */
  extern bool ggLoadObj(                // ǂݍ݂ł true
    const char *name,                   // ǂݍރt@C
    GLuint &nv,                         // ǂݍ񂾃f[^̒_
    GLfloat (*&vert)[3],                // ǂݍ񂾃f[^̒_ʒu
    GLfloat (*&norm)[3],                // ǂݍ񂾃f[^̒_@
    GLuint &nf,                         // ǂݍ񂾃f[^̎Op`
    GLuint (*&face)[3],                 // ǂݍ񂾃f[^̎Op`̒_CfbNX
    bool normalize                      // true Ȃǂݍ񂾃f[^̑傫𐳋K
    );

  /*
  ** Op`ꂽ OBJ t@C MTL t@Cǂݍ (Arrays `)
  */
  extern bool ggLoadObj(                // ǂݍ݂ł true
    const char *name,                   // ǂݍރt@C
    GLuint &ng,                         // ǂݍ񂾃f[^̃|SO[v
    GLuint (*&group)[2],                // ǂݍ񂾃f[^̃|SO[v̍ŏ̃|S̃CfbNXƃ|S
    GLfloat (*&ka)[4],                  // ǂݍ񂾂f[^̃|SO[vƂ̊ɑ΂锽ˌW
    GLfloat (*&kd)[4],                  // ǂݍ񂾂f[^̃|SO[vƂ̊gUˌW
    GLfloat (*&ks)[4],                  // ǂݍ񂾂f[^̃|SO[vƂ̋ʔˌW
    GLfloat *&kshi,                     // ǂݍ񂾂f[^̃|SO[vƂ̋PW
    GLuint &nv,                         // ǂݍ񂾃f[^̒_
    GLfloat (*&vert)[3],                // ǂݍ񂾃f[^̒_ʒu
    GLfloat (*&norm)[3],                // ǂݍ񂾃f[^̒_@
    bool normalize                      // true Ȃǂݍ񂾃f[^̑傫𐳋K
    );

  /*
  ** NX
  */
  class Gg
  {
  protected:

    // fXgN^
    ~Gg(void) {}

  public:

    // RXgN^
    Gg(void) {}
  };

  /*
  ** ϊs
  */
  class GgMatrix
    : public Gg
  {
    // ϊs̗vf
    GLfloat array[16];

    // s a ƃxNg b ̐ςxNg c ɑ
    void projection(GLfloat *c, const GLfloat *a, const GLfloat *b) const;

    // s a ƍs b ̐ςs c ɑ
    void multiply(GLfloat *c, const GLfloat *a, const GLfloat *b) const;

  public:

    // fXgN^
    virtual ~GgMatrix(void) {}

    // RXgN^
    GgMatrix(void) {}
    GgMatrix(const GLfloat *a)
    {
      load(a);
    }
    GgMatrix(const GgMatrix &m)
    {
      load(m);
    }

    // Zq
    GgMatrix &multiply(const GgMatrix &m, const GgMatrix &n)
    {
      multiply(array, m.array, n.array);
      return *this;
    }
    GgMatrix &multiply(const GgMatrix &m, const GLfloat *a)
    {
      multiply(array, m.array, a);
      return *this;
    }
    GgMatrix &multiply(const GLfloat *a)
    {
      GLfloat t[16];
      multiply(t, array, a);
      memcpy(array, t, sizeof array);
      return *this;
    }
    GgMatrix &multiply(const GgMatrix &m)
    {
      return multiply(m.array);
    }
    GgMatrix &operator=(const GLfloat *a)
    {
      return load(a);
    }
    GgMatrix &operator=(const GgMatrix &m)
    {
      return load(m);
    }
    GgMatrix operator*(const GLfloat *a) const
    {
      GgMatrix t;
      t.multiply(t.array, this->array, a);
      return t;
    }
    GgMatrix operator*(const GgMatrix &m) const
    {
      GgMatrix t;
      t.multiply(t.array, this->array, m.array);
      return t;
    }
    GgMatrix &operator*=(const GLfloat *a)
    {
      return multiply(a);
    }
    GgMatrix &operator*=(const GgMatrix &m)
    {
      return multiply(m);
    }

    // ϊs̓ǂݍ
    GgMatrix &load(const GLfloat *a)
    {
      memcpy(array, a, sizeof array);
      return *this;
    }
    GgMatrix &load(const GgMatrix &m)
    {
      return load(m.array);
    }

    // Pʍsݒ肷
    GgMatrix &loadIdentity(void);

    // sړ̕ϊsݒ肷
    GgMatrix &loadTranslate(GLfloat x, GLfloat y, GLfloat z, GLfloat w = 1.0f);
    GgMatrix &loadTranslate(const GLfloat *t)
    {
      return loadTranslate(t[0], t[1], t[2], t[3]);
    }

    // gk̕ϊsݒ肷
    GgMatrix &loadScale(GLfloat x, GLfloat y, GLfloat z, GLfloat w = 1.0f);
    GgMatrix &loadScale(const GLfloat *s)
    {
      return loadScale(s[0], s[1], s[2], s[3]);
    }

    // ]̕ϊsݒ肷
    GgMatrix &loadRotateX(GLfloat a);
    GgMatrix &loadRotateY(GLfloat a);
    GgMatrix &loadRotateZ(GLfloat a);
    GgMatrix &loadRotate(GLfloat x, GLfloat y, GLfloat z, GLfloat a);
    GgMatrix &loadRotate(const GLfloat *r)
    {
      return loadRotate(r[0], r[1], r[2], r[3]);
    }

    // ϊsݒ肷
    GgMatrix &loadLookat(GLfloat ex, GLfloat ey, GLfloat ez, GLfloat tx, GLfloat ty, GLfloat tz, GLfloat ux, GLfloat uy, GLfloat uz);
    GgMatrix &loadLookat(const GLfloat *e, const GLfloat *t, const GLfloat *u)
    {
      return loadLookat(e[0], e[1], e[2], t[0], t[1], t[2], u[0], u[1], u[2]);
    }

    // 𓊉eϊsݒ肷
    GgMatrix &loadOrthogonal(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);

    // eϊsݒ肷
    GgMatrix &loadFrustum(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);

    // pw肵ēeϊsݒ肷
    GgMatrix &loadPerspective(GLfloat fovy, GLfloat aspect, GLfloat zNear, GLfloat zFar);

    // ]usݒ肷
    GgMatrix &loadTranspose(const GgMatrix &m);

    // tsݒ肷
    GgMatrix &loadInvert(const GgMatrix &m);

    // @ϊsݒ肷
    GgMatrix &loadNormal(const GgMatrix &m);

    // sړϊ悶
    GgMatrix &translate(GLfloat x, GLfloat y, GLfloat z, GLfloat w = 1.0f)
    {
      GgMatrix m;
      m.loadTranslate(x, y, z, w);
      multiply(m);
      return *this;
    }
    GgMatrix &translate(const GLfloat *t)
    {
      return translate(t[0], t[1], t[2], t[3]);
    }

    // gkϊ悶
    GgMatrix &scale(GLfloat x, GLfloat y, GLfloat z, GLfloat w = 1.0f)
    {
      GgMatrix m;
      m.loadScale(x, y, z, w);
      multiply(m);
      return *this;
    }
    GgMatrix &scale(const GLfloat *s)
    {
      return scale(s[0], s[1], s[2], s[3]);
    }

    // ]ϊ悶
    GgMatrix &rotateX(GLfloat a)
    {
      GgMatrix m;
      m.loadRotateX(a);
      multiply(m);
      return *this;
    }
    GgMatrix &rotateY(GLfloat a)
    {
      GgMatrix m;
      m.loadRotateY(a);
      multiply(m);
      return *this;
    }
    GgMatrix &rotateZ(GLfloat a)
    {
      GgMatrix m;
      m.loadRotateZ(a);
      multiply(m);
      return *this;
    }
    GgMatrix &rotate(GLfloat x, GLfloat y, GLfloat z, GLfloat a)
    {
      GgMatrix m;
      m.loadRotate(x, y, z, a);
      multiply(m);
      return *this;
    }
    GgMatrix &rotate(const GLfloat *r)
    {
      return rotate(r[0], r[1], r[2], r[3]);
    }

    // ϊ悶
    GgMatrix &lookat(GLfloat ex, GLfloat ey, GLfloat ez, GLfloat tx, GLfloat ty, GLfloat tz, GLfloat ux, GLfloat uy, GLfloat uz);
    GgMatrix &lookat(const GLfloat *e, const GLfloat *t, const GLfloat *u)
    {
      return lookat(e[0], e[1], e[2], t[0], t[1], t[2], u[0], u[1], u[2]);
    }

    // 𓊉eϊ悶
    GgMatrix &orthogonal(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);

    // eϊ悶
    GgMatrix &frustum(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);

    // pw肵ēeϊ悶
    GgMatrix &perspective(GLfloat fovy, GLfloat aspect, GLfloat zNear, GLfloat zFar);

    // ]us𓾂
    GgMatrix transpose(void) const
    {
      GgMatrix t;
      return t.loadTranspose(*this);
    }

    // ts𓾂
    GgMatrix invert(void) const
    {
      GgMatrix t;
      return t.loadInvert(*this);
    }

    // @ϊs𓾂
    GgMatrix normal(void) const
    {
      GgMatrix t;
      return t.loadNormal(*this);
    }

    // xNgɑ΂ēeϊs
    void projection(GLfloat *c, const GLfloat *v) const
    {
      projection(c, array, v);
    }

    // ϊso
    const GLfloat *get(void) const
    {
      return array;
    }
  };

  /*
  ** l
  */
  class GgQuaternion
    : public Gg
  {
    // l̗vf
    GLfloat array[4];

    // l p Ǝl q ̘al r ɋ߂
    void add(GLfloat *r, const GLfloat *p, const GLfloat *q) const;

    // l p Ǝl q ̍l r ɋ߂
    void subtract(GLfloat *r, const GLfloat *p, const GLfloat *q) const;

    // l p Ǝl q ̐ςl r ɋ߂
    void multiply(GLfloat *r, const GLfloat *p, const GLfloat *q) const;

    // l q \]̕ϊs m ɋ߂
    void toMatrix(GLfloat *m, const GLfloat *q) const;

    // ]̕ϊs m \l q ɋ߂
    void toQuaternion(GLfloat *q, const GLfloat *m) const;

    // ʐ` q  r  t ŕԂl p ɋ߂
    void slerp(GLfloat *p, const GLfloat *q, const GLfloat *r, GLfloat t) const;

  public:

    // fXgN^
    virtual ~GgQuaternion(void) {}

    // RXgN^
    GgQuaternion(void) {}
    GgQuaternion(GLfloat x, GLfloat y, GLfloat z, GLfloat w)
    {
      load(x, y, z, w);
    }
    GgQuaternion(const GLfloat *a)
    {
      load(a);
    }
    GgQuaternion(const GgQuaternion &q)
    {
      load(q);
    }

    // Zq
    GgQuaternion &operator=(const GLfloat *a)
    {
      return load(a);
    }
    GgQuaternion &operator=(const GgQuaternion &q)
    {
      return load(q);
    }
    GgQuaternion operator+(const GLfloat *a) const
    {
      GgQuaternion t;
      t.add(t.array, this->array, a);
      return t;
    }
    GgQuaternion operator+(const GgQuaternion &q) const
    {
      GgQuaternion t;
      t.add(t.array, this->array, q.array);
      return t;
    }
    GgQuaternion &operator+=(const GLfloat *a)
    {
      return add(a);
    }
    GgQuaternion &operator+=(const GgQuaternion &q)
    {
      return add(q);
    }
    GgQuaternion operator-(const GLfloat *a) const
    {
      GgQuaternion t;
      t.subtract(t.array, this->array, a);
      return t;
    }
    GgQuaternion operator-(const GgQuaternion &q) const
    {
      GgQuaternion t;
      t.subtract(t.array, this->array, q.array);
      return t;
    }
    GgQuaternion &operator-=(const GLfloat *a)
    {
      return subtract(a);
    }
    GgQuaternion &operator-=(const GgQuaternion &q)
    {
      return subtract(q);
    }
    GgQuaternion operator*(const GLfloat *a) const
    {
      GgQuaternion t;
      t.multiply(t.array, this->array, a);
      return t;
    }
    GgQuaternion operator*(const GgQuaternion &q) const
    {
      GgQuaternion t;
      t.multiply(t.array, this->array, q.array);
      return t;
    }
    GgQuaternion &operator*=(const GLfloat *a)
    {
      return multiply(a);
    }
    GgQuaternion &operator*=(const GgQuaternion &q)
    {
      return multiply(q);
    }

    // lݒ肷
    GgQuaternion &load(GLfloat x, GLfloat y, GLfloat z, GLfloat w)
    {
      array[0] = x;
      array[1] = y;
      array[2] = z;
      array[3] = w;
      return *this;
    }
    GgQuaternion &load(const GLfloat *a)
    {
      return load(a[0], a[1], a[2], a[3]);
    }
    GgQuaternion &load(const GgQuaternion &q)
    {
      return load(q.array);
    }

    // ]̕ϊs m \lݒ肷
    GgQuaternion &loadMatrix(const GLfloat *m)
    {
      toQuaternion(array, m);
      return *this;
    }

    // Pʌݒ肷
    GgQuaternion &loadIdentity(void)
    {
      return load(0.0f, 0.0f, 0.0f, 1.0f);
    }

    // (x, y, z) ƂĊpx a ]鎑ݒ肷
    GgQuaternion &loadRotate(GLfloat x, GLfloat y, GLfloat z, GLfloat a);
    GgQuaternion &loadRotate(const GLfloat *v, GLfloat a)
    {
      return loadRotate(v[0], v[1], v[2], a);
    }

    // IC[p (h, p, r) ŗ^ꂽ]\lݒ肷
    GgQuaternion &loadEuler(GLfloat h, GLfloat p, GLfloat r);
    GgQuaternion &loadEuler(const GLfloat *e)
    {
      return loadEuler(e[0], e[1], e[2]);
    }

    // l̘a߂
    GgQuaternion &add(const GgQuaternion &p, const GgQuaternion &q)
    {
      add(array, p.array, q.array);
      return *this;
    }
    GgQuaternion &add(const GgQuaternion &q, const GLfloat *a)
    {
      add(array, q.array, a);
      return *this;
    }
    GgQuaternion &add(const GLfloat *a)
    {
      GLfloat t[4];
      add(t, array, a);
      return load(t);
    }
    GgQuaternion &add(const GgQuaternion &q)
    {
      return add(q.array);
    }

    // l̍߂
    GgQuaternion &subtract(const GgQuaternion &p, const GgQuaternion &q)
    {
      subtract(array, p.array, q.array);
      return *this;
    }
    GgQuaternion &subtract(const GgQuaternion &q, const GLfloat *a)
    {
      subtract(array, q.array, a);
      return *this;
    }
    GgQuaternion &subtract(const GLfloat *a)
    {
      GLfloat t[4];
      subtract(t, array, a);
      return load(t);
    }
    GgQuaternion &subtract(const GgQuaternion &q)
    {
      return subtract(q.array);
    }

    // l̐ς߂
    GgQuaternion &multiply(const GgQuaternion &p, const GgQuaternion &q)
    {
      multiply(array, p.array, q.array);
      return *this;
    }
    GgQuaternion &multiply(const GgQuaternion &q, const GLfloat *a)
    {
      multiply(array, q.array, a);
      return *this;
    }
    GgQuaternion &multiply(const GLfloat *a)
    {
      GLfloat t[4];
      multiply(t, array, a);
      return load(t);
    }
    GgQuaternion &multiply(const GgQuaternion &q)
    {
      return multiply(q.array);
    }

    // ʐ`
    GgQuaternion &slerp(const GgQuaternion &q, const GgQuaternion &r, GLfloat t)
    {
      slerp(array, q.array, r.array, t);
      return *this;
    }
    GgQuaternion &slerp(const GgQuaternion &q, const GLfloat *b, GLfloat t)
    {
      slerp(array, q.array, b, t);
      return *this;
    }
    GgQuaternion &slerp(const GLfloat *a, const GgQuaternion &r, GLfloat t)
    {
      slerp(array, a, r.array, t);
      return *this;
    }
    GgQuaternion &slerp(const GLfloat *a, const GLfloat *b, GLfloat t)
    {
      slerp(array, a, b, t);
      return *this;
    }
    GgQuaternion &slerp(const GgQuaternion &r, GLfloat t)
    {
      slerp(array, array, r.array, t);
      return *this;
    }
    GgQuaternion &slerp(GLfloat *b, GLfloat t)
    {
      slerp(array, array, b, t);
      return *this;
    }

    // l̃m߂
    GLfloat norm(void) const;

    // l߂
    GgQuaternion conjugate(void) const;

    // l̋t߂
    GgQuaternion invert(void) const;

    // l𐳋K
    GgQuaternion normalize(void) const;

    // lo
    const GLfloat *get(void) const
    {
      return array;
    }
    void get(GLfloat *a) const
    {
      a[0] = array[0];
      a[1] = array[1];
      a[2] = array[2];
      a[3] = array[3];
    }

    // l\]̍s m ɋ߂
    void getMatrix(GLfloat *m) const
    {
      toMatrix(m, array);
    }
  };

  /*
  ** ȈՃgbN{[
  */
  class GgTrackball
    : public Gg
  {
    int cx, cy;       // hbOJnʒu
    bool drag;        // hbOۂ
    float sx, sy;     // }EX̐ΈʒuEBhEł̑ΈʒůZW
    GgQuaternion cq;  // ]̏l (l)
    GgQuaternion tq;  // hbỎ] (l)
    GLfloat rt[16];   // ]̕ϊs

  public:

    // fXgN^
    virtual ~GgTrackball(void) {}

    // RXgN^
    GgTrackball(void);

    // gbN{[͈͎̔w
    //    EBhẼTCYɌĂяo
    void region(int w, int h);

    // gbN{[̊Jn
    //    }EX̃hbOJni}EX{^ƂjɌĂяo
    void start(int x, int y);

    // ]̕ϊšvZ
    //    }EX̃hbOɌĂяo
    void motion(int x, int y);

    // gbN{[̒~
    //    }EX̃hbOIi}EX{^𗣂ƂjɌĂяo
    void stop(int x, int y);

    // ݂̉]̕ϊso
    const GLfloat *get(void) const
    {
      return rt;
    }
  };

  /*
  ** QƃJE^
  **
  **     ̑f[^ԂŋL郊\[X̊mۂƉǗ
  */
  class GgCounter
    : public Gg
  {
    friend class GgAttribute;

    // QƃJEg
    unsigned int count;

    // fXgN^
    ~GgCounter(void) {}

    // RXgN^
    GgCounter(void)
      : count(0) {}
  };

  /*
  ** f[^
  **
  **     eNX`ƃVF[_̊NX
  **     CX^X͕̃IuWFNgQƂ邱Ƃz肷
  **     ̂߂̃NXł͎QƃJEgǗ
  */
  class GgAttribute
    : public Gg
  {
    // QƃJE^
    GgCounter *ref;

    // QƃJEg̑
    void inc(void)
    {
      ++ref->count;
    }

  protected:

    // QƃJEǧ
    unsigned int dec(void)
    {
      return --ref->count;
    }

  public:

    // fXgN^
    virtual ~GgAttribute(void)
    {
      if (ref->count == 0) delete ref;
    }

    // RXgN^
    GgAttribute(void)
      : ref(new GgCounter)
    {
      inc();
    }
    GgAttribute(const GgAttribute &o)
      : ref(o.ref)
    {
      inc();
    }

    // 
    GgAttribute &operator=(const GgAttribute &o)
    {
      if (&o != this)
      {
        ref = o.ref;
        inc();
      }
      return *this;
    }
  };

  /*
  ** eNX`
  **
  **     J[摜ǂݍŃeNX`}bv쐬
  */
  class GgTexture
    : public GgAttribute
  {
    // eNX`
    GLuint texture;

  public:

    // fXgN^
    virtual ~GgTexture(void)
    {
      if (dec() == 0) glDeleteTextures(1, &texture);
    }

    // RXgN^
    GgTexture(void)
    {
      glGenTextures(1, &texture);
    }
    GgTexture(GLsizei width, GLsizei height, GLenum internal = GL_RGBA, GLenum format = GL_RGBA, const GLvoid *image = 0)
    {
      glGenTextures(1, &texture);
      glBindTexture(GL_TEXTURE_2D, texture);
      ggLoadTexture(width, height, internal, format, image);
      glBindTexture(GL_TEXTURE_2D, 0);
    }
    GgTexture(const char *name, GLenum internal = GL_RGBA)
    {
      glGenTextures(1, &texture);
      glBindTexture(GL_TEXTURE_2D, texture);
      ggLoadImage(name, internal);
      glBindTexture(GL_TEXTURE_2D, 0);
    }
    GgTexture(const GgTexture &o)
      : GgAttribute(o), texture(o.texture) {}

    // 
    GgTexture &operator=(const GgTexture &o)
    {
      if (&o != this)
      {
        GgAttribute::operator=(o);
        texture = o.texture;
      }
      return *this;
    }

    // eNX`IuWFNg
    //     ̃eNX`gpۂɌĂяo
    //     unit: gpeNX`jbgԍi0`j
    void use(GLuint unit = 0) const
    {
      glActiveTexture(GL_TEXTURE0 + unit);
      glBindTexture(GL_TEXTURE_2D, texture);
    }

    // eNX`IuWFNg
    //    ̃eNX`gpȂȂĂяo
    void unuse(void) const
    {
      glBindTexture(GL_TEXTURE_2D, 0);
      glActiveTexture(GL_TEXTURE0);
    }

    // eNX`IuWFNgo
    GLuint get(void) const
    {
      return texture;
    }
  };

  /*
  ** @}bv
  **
  **     }bviOCXP[摜jǂݍŖ@}bv쐬
  */
  class GgNormalTexture
    : public GgTexture
  {
  public:

    // fXgN^
    virtual ~GgNormalTexture(void) {}

    // RXgN^
    GgNormalTexture(void) {}
    GgNormalTexture(
      const char *name,                   // 摜t@Ci1 `l TGA 摜j
      float nz = 1.0f                     // @}bv z ̒l
      )
      : GgTexture()
    {
      glBindTexture(GL_TEXTURE_2D, get());
      ggLoadHeight(name, nz);
      glBindTexture(GL_TEXTURE_2D, 0);
    }
    GgNormalTexture(const GgNormalTexture &o)
      : GgTexture(o) {}

    // 
    GgNormalTexture &operator=(const GgNormalTexture &o)
    {
      GgTexture::operator=(o);
      return *this;
    }
  };

  /*
  ** VF[_
  **
  **     VF[_̊NX
  */
  class GgShader
    : public GgAttribute
  {
    // vO
    GLuint program;

  public:

    // fXgN^
    virtual ~GgShader(void)
    {
      if (dec() == 0 && program != 0) glDeleteProgram(program);
    }

    // RXgN^
    GgShader(void)
      : program(0) {}
    GgShader(
      const char *vert,                   // o[ebNXVF[_̃\[Xt@C
      const char *frag = 0,               // tOgVF[_̃\[Xt@Ci0 Ȃsgpj
      const char *geom = 0,               // WIgVF[_̃\[Xt@Ci0 Ȃsgpj
      GLenum input = GL_TRIANGLES,        // WIgVF[_̓̓v~eBu
      GLenum output = GL_TRIANGLE_STRIP,  // WIgVF[_̏o̓v~eBu
      int vertices = 0,                   // WIgVF[_̏o͒_
      int nvarying = 0,                   // tB[hobN varying ϐ̐i0 Ȃsgpj
      const char **varyings = 0           // tB[hobN varying ϐ̃Xg
      )
      : program(ggLoadShader(vert, frag, geom, input, output, vertices, nvarying, varyings)) {}
    GgShader(const GgShader &o)
      : GgAttribute(o), program(o.program) {}

    // 
    GgShader &operator=(const GgShader &o)
    {
      if (&o != this)
      {
        GgAttribute::operator=(o);
        program = o.program;
      }
      return *this;
    }

    // VF[_̃\[XvO̓ǂݍ݂ƃRpCEN
    void load(
      const char *vert,                   // o[ebNXVF[_̃\[Xt@C
      const char *frag = 0,               // tOgVF[_̃\[Xt@Ci0 Ȃsgpj
      const char *geom = 0,               // WIgVF[_̃\[Xt@Ci0 Ȃsgpj
      GLenum input = GL_TRIANGLES,        // WIgVF[_̓̓v~eBu
      GLenum output = GL_TRIANGLE_STRIP,  // WIgVF[_̏o̓v~eBu
      GLint vertices = 0,                 // WIgVF[_̏o͒_
      GLint nvarying = 0,                 // tB[hobN varying ϐ̐i0 Ȃsgpj
      const char **varyings = 0           // tB[hobN varying ϐ̃Xg
      )
    {
      if (program != 0) glDeleteProgram(program);
      program = ggLoadShader(vert, frag, geom, input, output, vertices, nvarying, varyings);
    }

    // VF[_vO̎gpJn
    virtual void use(GLuint vert, ...) const
    {
      glUseProgram(program);
    }

    // VF[_vO̎gpI
    virtual void unuse(void) const
    {
      glBindBuffer(GL_ARRAY_BUFFER, 0);
      glUseProgram(0);
    }

    // VF[_vOo
    GLuint get(void) const
    {
      return program;
    }
  };

  /*
  ** obt@IuWFNg
  **
  **    _^CfbNXobt@IuWFNg̊NX
  */
  template <typename T>
  class GgBuffer
    : public GgAttribute
  {
    // obt@IuWFNg
    GLuint buffer;

    // f[^
    GLuint number;

  public:

    // fXgN^
    virtual ~GgBuffer<T>(void)
    {
      if (dec() == 0) glDeleteBuffers(1, &buffer);
    }

    // RXgN^
    GgBuffer<T>(void)
      : number(0)
    {
      glGenBuffers(1, &buffer);
    }
    GgBuffer<T>(GLenum target, GLuint n, const T *data, GLenum usage = GL_STATIC_DRAW)
    {
      glGenBuffers(1, &buffer);
      load(target, n, data, usage);
    }
    GgBuffer<T>(const GgBuffer<T> &o)
      : GgAttribute(o), buffer(o.buffer), number(o.number) {}

    // 
    GgBuffer<T> &operator=(const GgBuffer<T> &o)
    {
      if (&o != this)
      {
        GgAttribute::operator=(o);
        buffer = o.buffer;
        number = o.number;
      }
      return *this;
    }

    // obt@IuWFNgɃf[^i[
    void load(GLenum target, GLuint n, const T *data, GLenum usage = GL_STATIC_DRAW)
    {
      number = n;
      glBindBuffer(target, buffer);
      glBufferData(target, sizeof (T) * n, data, usage);
    }

    // obt@IuWFNg̃f[^𕡎ʂ
    void copy(GLuint buf)
    {
      const size_t size = sizeof (T) * number;
#ifdef __APPLE__
      T *temp = new T[number];
      glBindBuffer(GL_ARRAY_BUFFER, buf);
      glGetBufferSubData(GL_ARRAY_BUFFER, 0, size, temp);
      glBindBuffer(GL_ARRAY_BUFFER, buffer);
      glBufferSubData(GL_ARRAY_BUFFER, 0, size, temp);
      glBindBuffer(GL_ARRAY_BUFFER, 0);
      delete[] temp;
#else
      glBindBuffer(GL_COPY_READ_BUFFER, buf);
      glBindBuffer(GL_COPY_WRITE_BUFFER, buffer);
      glCopyBufferSubData(GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, 0, 0, size);
      glBindBuffer(GL_COPY_WRITE_BUFFER, 0);
      glBindBuffer(GL_COPY_READ_BUFFER, 0);
#endif
    }

    // obt@IuWFNgo
    GLuint buf(void) const
    {
      return buffer;
    }

    // f[^̐o
    GLuint num(void) const
    {
      return number;
    }
  };

  /*
  ** `f[^
  **
  **    `f[^̊NX
  **    ̃NXgpVF[_QƂ
  **    VF[_̃CX^XQƃJEgCNg
  **    VF[_̃CX^X̌QƃJEgfNgC0 ɂȂVF[_폜
  */
  class GgShape
    : public Gg
  {
    // VF[_[
    GgShader *shader;

  protected:

    // `}`
    GLenum mode;

  public:

    // fXgN^
    virtual ~GgShape(void) {}

    // RXgN^
    GgShape(void)
      : shader(0), mode(GL_POINTS) {}
    GgShape(const GgShape &o)
      : shader(o.shader), mode(o.mode) {}

    // Zq
    GgShape &operator=(const GgShape &o)
    {
      if (this != &o)
      {
        attachShader(o.shader);
        mode = o.mode;
      }
      return *this;
    }

    // `f[^ɃVF[_̃CX^X s 
    //    ܂ŌĂVF[_̎QƃJEgfNg 0 ɂȂ炻̃VF[_j
    //    VVF[_ s  s ̎QƃJEgCNg
    void attachShader(GgShader *s)
    {
      shader = s;
    }
    void attachShader(GgShader &s)
    {
      shader = &s;
    }

    // ̌`f[^ŎgpĂVF[_o
    GgShader *getShader(void) const
    {
      return shader;
    }

    // `Ɏg{}`ݒ肷
    void setMode(GLenum m)
    {
      mode = m;
    }

    // ̌``悷葱I[o[Ch
    virtual void draw(void) const = 0;
  };

  /*
  ** |Cg
  */
  class GgPoints
    : public GgShape
  {
    // _obt@IuWFNg
    GgBuffer<GLfloat[3]> position;

  public:

    // fXgN^
    virtual ~GgPoints(void) {}

    // RXgN^
    GgPoints(void) {}
    GgPoints(GLuint n, const GLfloat (*pos)[3], GLenum usage = GL_STATIC_DRAW)
    {
      load(n, pos, usage);
      mode = GL_POINTS;
    }
    GgPoints(const GgPoints &o)
      : GgShape(o), position(o.position) {}

    // 
    GgPoints &operator=(const GgPoints &o)
    {
      if (&o != this)
      {
        GgShape::operator=(o);
        position = o.position;
      }
      return *this;
    }

    // obt@IuWFNgmۂĒ_i[
    //    n: _, pos: _̈ʒu
    void load(GLuint n, const GLfloat (*pos)[3], GLenum usage = GL_STATIC_DRAW)
    {
      position.load(GL_ARRAY_BUFFER, n, pos, usage);
    }

    // obt@IuWFNgo
    GLuint pbuf(void) const
    {
      return position.buf();
    }

    // f[^̐o
    GLuint pnum(void) const
    {
      return position.num();
    }

    // |Cg̕`
    virtual void draw(void) const;
  };

  /*
  ** |S
  */
  class GgTriangles
    : public GgPoints
  {
    // _̖@xNg
    GgBuffer<GLfloat[3]> normal;

  public:

    // fXgN^
    virtual ~GgTriangles(void) {}

    // RXgN^
    GgTriangles(void) {}
    GgTriangles(GLuint n, const GLfloat (*pos)[3], const GLfloat (*norm)[3], GLenum usage = GL_STATIC_DRAW)
      : GgPoints(n, pos, usage)
    {
      normal.load(GL_ARRAY_BUFFER, n, norm, usage);
      mode = GL_TRIANGLES;
    }
    GgTriangles(const GgTriangles &o)
      : GgPoints(o), normal(o.normal) {}

    // 
    GgTriangles &operator=(const GgTriangles &o)
    {
      if (&o != this)
      {
        GgPoints::operator=(o);
        normal = o.normal;
      }
      return *this;
    }

    // obt@IuWFNgmۂĈʒuƖ@i[
    //    n: _, pos: _̈ʒu, norm: _̖@
    void load(GLuint n, const GLfloat (*pos)[3], const GLfloat (*norm)[3], GLenum usage = GL_STATIC_DRAW)
    {
      GgPoints::load(n, pos, usage);
      normal.load(GL_ARRAY_BUFFER, n, norm, usage);
    }

    // obt@IuWFNgo
    GLuint nbuf(void) const
    {
      return normal.buf();
    }

    // f[^̐o
    GLuint nnum(void) const
    {
      return normal.num();
    }

    // Op`Q`悷葱
    virtual void draw(void) const;
  };

  /*
  ** Op`̌`f[^
  */
  class GgElements
    : public GgTriangles
  {
    // CfbNXobt@IuWFNg
    GgBuffer<GLuint[3]> index;

  public:

    // fXgN^
    virtual ~GgElements(void) {}

    // RXgN^
    GgElements(void) {}
    GgElements(GLuint n, const GLfloat (*pos)[3], const GLfloat (*norm)[3],
      GLuint f, const GLuint (*face)[3], GLenum usage = GL_STATIC_DRAW)
      : GgTriangles(n, pos, norm, usage)
    {
      index.load(GL_ELEMENT_ARRAY_BUFFER, f, face);
    }
    GgElements(const GgElements &o)
      : GgTriangles(o), index(o.index) {}

    // 
    GgElements &operator=(const GgElements &o)
    {
      if (&o != this)
      {
        GgTriangles::operator=(o);
        index = o.index;
      }
      return *this;
    }

    // obt@IuWFNgmۂĈʒuƖ@ƃCfbNXi[
    //    n: _, pos: _̈ʒu, norm:_̖@
    //    f: ʐ, face: _̃CfbNXf[^
    void load(GLuint n, const GLfloat (*pos)[3], const GLfloat (*norm)[3],
      GLuint f, const GLuint (*face)[3], GLenum usage = GL_STATIC_DRAW)
    {
      GgTriangles::load(n, pos, norm, usage);
      index.load(GL_ELEMENT_ARRAY_BUFFER, f, face);
    }

    // obt@IuWFNgo
    GLuint fbuf(void) const
    {
      return index.buf();
    }

    // f[^̐o
    GLuint fnum(void) const
    {
      return index.num();
    }

    // Op`|S`悷葱
    virtual void draw(void) const;
  };

  /*
  ** ̃|Cg
  */
  extern GgPoints *ggPointSphere(GLuint nv, GLfloat cx = 0.0f, GLfloat cy = 0.0f, GLfloat cz = 0.0f, GLfloat radius = 0.5f);

  /*
  ** `
  */
  extern GgTriangles *ggRectangle(GLfloat width = 1.0f, GLfloat height = 1.0f);

  /*
  ** ȉ~
  */
  extern GgTriangles *ggEllipse(GLfloat width = 1.0f, GLfloat height = 1.0f, GLuint slices = 16);

  /*
  ** Op`ꂽ Alias OBJ t@C (Arrays `)
  */
  extern GgTriangles *ggArraysObj(const char *name, bool normalize = false);

  /*
  ** Op`ꂽ Alias OBJ t@C (Elements `)
  */
  extern GgElements *ggElementsObj(const char *name, bool normalize = false);
}

#endif
